<!-- -*- mode: markdown; mode: flyspell -*- -->

# ZKK LVATest-Env Apps0 Scripts

Contains scripts used on apps0 (application server for staff running
exams using the LVATest-Env).

For a general into of the lvatest-env please take a look into
[share/STAFF-README.md](share/STAFF-README.md). This file can be found
on apps0 as `/usr/share/zkk-lvatest-apps0-scripts/STAFF-README.md` and
for course staff there is a symlink to that file called
`/home/data/README.md`.

## etc

Contains sudo config for webstatus-service.

## bin

Scripts targeted for staff of the course running the exam.

### `lvatest-status`

Shows the state of the host.

Synopsis:
```
lvatest-status: usage: lvatest-status [-l | -q]
  where -l requests a long description including rollout timestamp
    and -q does not output anything but returns 0 if state is 
           boottime-ok or delayed and 1 otherwise
```

### `lvatest-collect`

Collects results from a set of target hosts of the current
lab. Accepts ranges by using range-expand library.

Synopsis:
```bash
lvatest-collect <range> [..]
 where range can be:
   <number>            .. expands to "<lab-pc-prefix><number>"
   <number1>-<number2> .. expands like above for all numbers in range
   <string>            .. expands to macro contents if exists else to <string>
```

### lvatest-status-control

Just a sudo wrapper for the same script in webstatus/bin.

### lvatest-data-push

Script for lvatest staff to mirror the contents of their dir in
`/home/data` to apps0 servers in other labs.

Synopsis:
```bash
lvatest-data-push <test-name> [ <destination> [..]]
 # if no destination is specified, all other labs are used
```

## webstatus

This is the webstatus service using nginx. It allows lvatest-staff to
start control a website that displays the status of an ongoing
examination.

The webstatus tree will be installed on `/opt/lvatest-webstatus`.

### webstatus/bin

#### lvatest-collect-status

That script connects to hosts with SSH and collects info about a
running or delayed lvatest.

#### lvatest-status-control

Controls behavior of lvatest-webstatus-service by modifications oif
content in webstatus/var. Call with help to get usage info.

#### lvatest-webstatus-disable

Special script that modifies links webstatus/html/index.html to a page
that states the service is currently offline. This script does not
touch webstatus/var contents, so once systemd service is re-enabled it
will continue with the configured job.

#### lvatest-webstatus-service

The webstatus-service. Started by systemd. Depending on contents of
webstatus/vara it will collect info or not.

### webstatus/html

This dir is exported by nginx. It contains the `idle.html` page which
displays info for lvatest staff. While active information is stored in
`status.html`. The symlink `index.html` will point to one of those
files, depending if active or idle.

### webstatus/var

This dir contains runtime stuff.

#### active

If this file exists the service is active and it must contain a number
from 1 to 23 which is the hour to go idle.

#### scope

This file contains the scope of operation as whitespace separated list
of ranges in one line.

<!--
Localwords: webstatus nginx lvatest dir runtime whitespace html
-->
